
from org.gvsig.fmap.dal.feature.impl import DefaultFeature as JFeature

class Feature(JFeature):
  """Represents feature data It's a wrapper from gvSIG 
  """
  def __init__(self,feature):
    WrapperToJava.__init__(self,feature)
    self.featureNoEditable = None

  def geometry(self):
    """Returns feature geometry"""
    return self.getDefaultGeometry()
   
  def getValues(self):
    """Returns dictionary with the pair name, value, feature attributes"""
    descriptor = self.getType()
    items = dict()
    for attr in descriptor.getAttributeDescriptors():
      name = attr.getName()
      value = self.get(attr.getName())
      items[name] = value
    return items 
  
  def edit(self):
    """Returns editable feature instance"""
    if not isinstance(self._javaobj, EditableFeature):
      self.featureNoEditable = self._javaobj
      self._javaobj = self._javaobj.getEditable()
  
  def __getitem__(self,key):
    return self.get(key)
  
  def __getattr__(self,name):
    #
    #FIX console error when try to introspect feature object
    if name in ('__methods__'):
        return dict()
    elif name in ('__members__'):
        return self.getValues().keys()
    elif name == '__dict__':
        return self.getValues()      
        
    try:
      v = getattr(self._javaobj, name, None)
      if v == None:
        v = self().get(name)        
      return v
    except Throwable, ex:
      raise RuntimeException("Can't access to attribute %s of feature (%s)" % (name, str(ex)))    

