

from org.gvsig.fmap.mapcontext.layers.vectorial import FLyrVect as JLayerVectorial
from table import DataTable

class LayerVectorial(JLayerVectorial,DataTable):
  """
  This class represent a vectorial layer.
  
  Extends the `java FLyrVect`_ class.
  
  .. _`java FLyrVect` : FIXME_URL
  """

  def getProjectionCode(self):
    """
    Returns projection code name of the layer.
    
    :return:
      the projection code name of the layer.
    :returntype:
      String
    """
    return self.getProjection().getFullCode()

  def __call__(self):
    """
    Return the java object represented by this object.
    
    This method is for compatibility with scripting API of gvSIG 2.0
    
    :ReturnType:
      LayerVectorial
    :deprecated: 
      With gvSIG 2.1 the call this method isn't necesary
      
    """
    return self    


#
# Inject new methods in the class JLayerVectorial
#
JLayerVectorial.getProjectionCode = LayerVectorial.getProjectionCode
JLayerVectorial.__call__ = LayerVectorial.__call__
JLayerVectorial.features = DataTable.features
JLayerVectorial.edit = DataTable.edit
JLayerVectorial.append = DataTable.append
JLayerVectorial.updateSchema = DataTable.updateSchema
JLayerVectorial.update = DataTable.update
JLayerVectorial.getSchema = DataTable.getSchema
JLayerVectorial.commit = DataTable.commit
JLayerVectorial.abort = DataTable.abort
JLayerVectorial.getSelection = DataTable.getSelection
JLayerVectorial.select = DataTable.select
JLayerVectorial.deselect = DataTable.deselect
JLayerVectorial.isSelected = DataTable.isSelected

