
  
class Selection(FeatureSet):
  """Manage selected features set from a store. Represents gvSIG 
  org.gvsig.fmap.dal.feature.impl.DefaultFeatureSelection.  
  """
  def __init__(self, featureSet):
    FeatureSet.__init__(self, featureSet)
      
  def select(self, selection):
    """Inserts features in the features selection set"""
    if isinstance(selection,Feature) or isinstance(selection, FeatureSet):
      self._javaobj.select(selection._javaobj)
    else:
      self._javaobj.select(selection)

  def deselect(self, selection):
    """Removes features in the features selection set"""
    if isinstance(selection,Feature) or isinstance(selection, FeatureSet):
      self._javaobj.deselect(selection._javaobj)
    else:
      self._javaobj.deselect(selection)

  def isSelected(feature):
    """Returns True if given feature is selected"""
    if isinstance(feature, Feature):
      self._javaobj.isSelect(feature._javaobj)
    else:
      self._javaobj.isSelect(feature)
      
  def getCount(self):
    """Returns the number of elements in the selection"""
    return self.getSelectedCount()
    

